# == Class: yaf
#
# Full description of class yaff here.
#
# === Parameters
#
# Document parameters here.
#
# [*sample_parameter*]
#   Explanation of what this parameter affects and what it defaults to.
#   e.g. "Specify one or more upstream ntp servers as an array."
#
# === Variables
#
# Here you should define a list of variables that this module would require.
#
# [*sample_variable*]
#   Explanation of how this variable affects the funtion of this class and if
#   it has a default. e.g. "The parameter enc_ntp_servers must be set by the
#   External Node Classifier as a comma separated list of hostnames." (Note,
#   global variables should be avoided in favor of class parameters as
#   of Puppet 2.6.)
#
# === Examples
#
#  class { yaf:
#    servers => [ 'pool.ntp.org', 'ntp.local.company.com' ],
#  }
#
# === Authors
#
# Author Name <author@domain.com>
#
# === Copyright
#
# Copyright 2014 Your name here, unless otherwise noted.
#
class yaf(
 $filestore = $yaf::params::filestore,
 $workspace = $yaf::params::workspace,
 $package = $yaf::params::package,
 $config_template = $yaf::params::config_template,
 $config_yaf_init_template = $yaf::params::config_yaf_init_template,
 $lib_fix_buf_folder = $yaf::params::lib_fix_buf_folder,
 $p0flib_folder = $yaf::params::p0flib_folder,
 $yaf_folder = $yaf::params::yaf_folder, 
 $yaf_cap_if       = $yaf::params::yaf_cap_if,
 $yaf_ipfix_host   = $yaf::params::yaf_ipfix_host,
 $yaf_ipfix_port   = $yaf::params::yaf_ipfix_port,
 $service_enable   = $yaf::params::service_enable,
 $service_ensure   = $yaf::params::service_ensure,
 $service_enable   = $yaf::params::service_enable,
 $service_name     = $yaf::params::service_name,
 $service_manage   = $yaf::params::service_manage,
) inherits yaf::params {
  anchor { 'yaf::begin': } ->
  class { '::yaf::install': 
    filestore => $filestore,
    workspace => $workspace,
    package => $package,
    lib_fix_buf_folder => $lib_fix_buf_folder,
    p0flib_folder => $p0flib_folder,
    yaf_folder    => $yaf_folder,
  } ->
  class { '::yaf::config':   } ~>
  class { '::yaf::service': 
   service_ensure => $service_ensure,
   service_enable => $service_enable,
   service_name   => $service_name,
   service_manage => $service_manage
  } ->
  anchor { 'yaf::end': }

}
