class yaf::install (
  $filestore,
  $package,
  $workspace,
  $lib_fix_buf_folder,
  $p0flib_folder,
  $yaf_folder,
)

{
  if $filestore {
    if ! defined(File[$workspace]) {
      file { $workspace:
        ensure => directory,
      }
    }
  }
  file { "${workspace}/$package":
    ensure  => present,
    source  => "${filestore}/$package",
  }
  exec { 'unpack-yaf-tarball':
    command     => "/bin/tar -zxf ${workspace}/${package}",
    cwd         => $workspace,
    creates     => "${workspace}/yaf",
    require     => File["${workspace}/${package}"],
  }
  exec { 'configure-libfixbuf':
    command	=> "/bin/sh ${workspace}/${lib_fix_buf_folder}/configure",
    cwd		=> $workspace,
    creates	=> "${workspace}/${lib_fix_buf_folder}/config.status",
    require     => Exec["unpack-yaf-tarball"], 
  }
  exec { 'make-libfixbuf':
    command     => "/usr/bin/make ${workspace}/${lib_fix_buf_folder}/",
    cwd         => $workspace,
    creates     => "${workspace}/${lib_fix_buf_folder}/src/Makefile",
    require     => Exec["configure-libfixbuf"],
  }
  exec { 'make-install-libfixbuf':
    command     => "/usr/bin/make install ${workspace}/${lib_fix_buf_folder}/",
    cwd         => $workspace,
    creates     => "/usr/local/lib/libfixbuf.so",
    require     => Exec["make-libfixbuf"],
  }
  exec { 'config-path-libfixbuf':
    command     => "/bin/bash -c export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig",
    cwd         => $workspace,
    require     => Exec["make-install-libfixbuf"],
  }
  exec { 'configure-libp0f':
    command     => "/bin/sh ${workspace}/${p0flib_folder}/configure",
    cwd		=> $workspace,
    creates     => "${workspace}/${p0flib_folder}/config.status",
    require     => Exec["unpack-yaf-tarball"],
  }
  exec { 'make-libp0f':
    command     => "/usr/bin/make ${workspace}/${p0flib_folder}/",
    cwd         => $workspace,
    creates     => "${workspace}/${p0flib_folder}/src/app/p0f",
    require     => Exec["configure-libp0f"],
  }
  exec { 'make-install-libp0f':
    command     => "/usr/bin/make install ${workspace}/${p0flib_folder}/",
    cwd         => $workspace,
    creates     => "/usr/local/lib/libp0f.so",
    require     => Exec["make-libp0f"],
  }
  exec { 'configure-yaf':
    command     => "/bin/sh ${workspace}/${yaf_folder}/configure --enable-plugins --enable-applabel --enable-entropy --enable-daginterface --enable-napatechinterface --enable-fpexporter --enable-p0fprinter",
    cwd         => $workspace,
    creates     => "${workspace}/${yaf_folder}/config.status",
    require     => Exec["config-path-libfixbuf"],
  }
  exec { 'make-yaf':
    command     => "/usr/bin/make ${workspace}/${yaf_folder}/",
    cwd         => $workspace,
    creates     => "${workspace}/${yaf_folder}/src/yaf",
    require     => Exec["configure-yaf"],
  }
  exec { 'make-install-yaf':
    command     => "/usr/bin/make install ${workspace}/${yaf_folder}/",
    cwd         => $workspace,
    creates     => "/usr/local/lib/libyaf.so",
    require     => Exec["make-yaf"],
  }

}
